\makeatletter
\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{CFexam}[2004/12/10 Version 1 COMSC LATEX TEAM]
\LoadClass[12pt,a4paper,twoside]{article}
\RequirePackage{times,fancyhdr}

\setlength{\textheight}{9.5in}
\setlength{\textwidth}{6.1in}
\setlength{\topmargin}{-0.5in}
\hoffset -0.4in

\renewcommand{\labelenumi}{(\alph{enumi})}
\renewcommand{\labelenumii}{\roman{enumii}.}

\newcommand{\examyear}[1]{\newcommand{\theexamyear}{#1}}
\newcommand{\examperiod}[1]{\newcommand{\theexamperiod}{#1}}
\newcommand{\examnumber}[1]{\newcommand{\theexamnumber}{#1}}
\newcommand{\examtitle}[1]{\newcommand{\theexamtitle}{#1}}
\newcommand{\duration}[1]{\newcommand{\theduration}{#1}}
\newcommand{\numberofpages}[1]{\newcommand{\thenumberofpages}{#1}}
\newcommand{\numberofsections}[1]{\newcommand{\thenumberofsections}{#1}}
\newcommand{\numberofquestions}[1]{\newcommand{\thenumberofquestions}{#1}}
\newcommand{\appendices}[1]{\newcommand{\theappendices}{#1}}
\newcommand{\stationery}[1]{\newcommand{\thestationery}{#1}}
\newcommand{\instructions}[1]{\newcommand{\theinstructions}{#1}}

\newcounter{sections}
\newcommand{\Section}[1]{\stepcounter{sections}\section*{Section #1}}

\newcounter{questions}
\newenvironment{Questions}
{\begin{list}{\stepcounter{questions}Q\arabic{questions}.}%
{\setlength\itemsep{1cm}}}
{\end{list}}

\numberofquestions{\ref{question@count}}
\numberofsections{\ref{section@count}}
\ifx\numericsection@count\@undefined\def\numericsection@count{1}\fi

\pagestyle{fancy}
\fancyhead{} \fancyfoot{}
\lhead[\em \theexamnumber]{}
\rhead[]{\em \theexamnumber}
\renewcommand{\headrulewidth}{0pt}
\renewcommand{\headheight}{15pt}
\cfoot{\thepage}
\rfoot[]{PLEASE TURN OVER}

\AtEndDocument{
\protected@write\@auxout{}%
       {\string\newlabel{question@count}{{\arabic{questions}}{\arabic{page}}}}%
\protected@write\@auxout{}%
       {\string\newlabel{section@count}{{\arabic{sections}}{\arabic{page}}}}%
\protected@write\@auxout{}%
       {\string\gdef\string\numericsection@count{\arabic{sections}}}%
\cfoot{\thepage{}X}
\rfoot{END OF EXAMINATION}
}

\newcommand{\makerubric}
{
\rhead[]{}
\noindent
\hspace{-3mm}
\begin{tabular}{ll}
\textbf{CARDIFF UNIVERSITY} & \\
\textbf{EXAMINATION PAPER} & \\ \\ \\ 
\textbf{Academic Year:} & \theexamyear \\ \\
\textbf{Examination Period:} & \theexamperiod \\ \\
\textbf{Examination Paper Number:} & \theexamnumber \\ \\
\textbf{Examination Paper Title:} & \theexamtitle \\ \\
\textbf{Duration:} & \theduration \\
\end{tabular}

\vspace{1cm}
\noindent
\textbf{Do not turn this page over until instructed to do so by the Senior 
Invigilator.}

\vspace{5mm}
\noindent
\textbf{Structure of Examination Paper:}
\vspace{5mm}

\noindent
There are 3 pages.
\ifnum \numericsection@count>1 {
\\
This examination paper is divided into \ref{section@count}~sections.
}\fi
\\
There are 4 questions in total.
\\
\theappendices
\\
The maximum mark 
obtainable for a question or part of a question is shown in brackets 
alongside the question. 

\vspace{5mm}
\noindent
\textbf{Students to be provided with:}
\vspace{5mm}

\noindent
The following items of stationery are to be provided:
\\
\thestationery.

\vspace{5mm}

\noindent
\textbf{Instructions to Students:}
\vspace{5mm}

\noindent
\theinstructions
\\
The use of translation dictionaries between English or Welsh and a foreign 
language bearing an appropriate departmental stamp is permitted in this 
examination.

\newpage
\rhead[]{\em \theexamnumber}
}

\makeatother
