% AI-LAB-II / Exercise 2

% GCD

gcd(A,B,GCD) :-
	A = B,
	GCD = A.

gcd(A,B,GCD) :-
	A < B,
	NB is B - A,
	gcd(A,NB,GCD).

gcd(A,B,GCD) :-
	A > B,
	NB is A - B,
	gcd(NB,A,GCD).

% Factorial I

fac(0,1).

fac(N,F) :-
	N > 0,
	M is N - 1,
	fac(M,F1),
	F is N * F1.

% Factorial II
% (with tail recursion using an accumulator argument)
% Call, e.g., as factorial(5,1,F).

factorial(0,F,F).

factorial(N,A,F) :-
	N > 0,
	A1 is N * A,
	M is N - 1,
	factorial(M, A1, F).

% Natural numbers.

natural_number(1).

natural_number(s(X)) :- natural_number(X).

less_than(1,s(X)) :-
	natural_number(X).

lessthan(s(X),s(Y)) :-
	less_than(X,Y).

less_than_or_equal(0,X) :-
	natural_number(X).

less_than_or_equal(s(X),s(Y)) :-
	less_than_or_equal(X,Y).

even(s(1)).

even(s(s(X))) :-
	even(X).
	
plus(1,N,N) :-
	natural_number(N).

plus(s(M),N,s(Z)) :-
	plus(M,N,Z).

times(1,N,N) :-
	natural_number(N).

times(s(M),N,Z) :-
	times(M,N,W),
	plus(W,N,Z).
