// agent_simple.cc: Simple test agent.
// 
// Copyright (C) 2004 Frank Langbein <frank@langbein.org>
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// $Id: main.cc,v 2.7 2003/09/01 12:30:26 scmfcl Exp $

#include "config.h"
#include "stdio.h"

RCSID (agent_simple, "$Id$");

int main (int argc, char **argv)
{
  srand (time (NULL));

  // Identify myself
  cout << "AGENT" << endl;

  // World info
  string in;
  cin >> in;
  int wX, wY;
  sscanf (in.c_str (), "WORLD:%d:%d", &wX, &wY);

  while (true) {

    cin >> in;
    if (in == "KILL") {
      cout << "DYING\n";
      break;
    }
    string atpos, sensor;
    long posx, posy, o;
    int p = in.find (':');
    atpos = in.substr (0, p);
    int l = in.find (':', p + 1);
    sensor = in.substr (p + 1, l - p);
    sscanf (in.substr (l + 1,string::npos) . c_str (), "%ld:%ld:%ld",
	    &posx, &posy, &o);
    if (atpos == "Collect_brown") {
      cout << "COLLECT\n";
    } else if (in.substr (0, 5) == "Empty") {
      bool t = true;
      while (t) {
	long m = static_cast<long> (4.0 * RAND);
	switch (m) {
	case 0:
	  if (posy + 1 < wY) {
	    cout << "Y+\n";
	    t = false;
	  }
	  break;
	case 1:
	  if (posy > 0) {
	    cout << "Y-\n";
	    t = false;
	  }
	  break;
	case 2:
	  if (posx + 1 < wX) {
	    cout << "X+\n";
	    t = false;
	  }
	  break;
	case 3:
	  if (posx > 0) {
	    cout << "X-\n";
	    t = false;
	  }
	  break;
	}
      }
    }
  }
  return 0;
}

/// Local Variables:          ***
/// compile-command: "make"   ***
/// End:                      ***
