// engine.hxx: robot engine.
// 
// Copyright (C) 2004 Frank Langbein <frank@langbein.org>
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// $Id: main.cc,v 2.7 2003/09/01 12:30:26 scmfcl Exp $

#ifndef ENGINE_HXX
#define ENGINE_HXX

class World;
class Agent;

class Engine {
public:
  Engine (World *w, SimpleList<string> *an, double spos, double sangle);
  ~Engine ();
  void run ();
  void edisplay ();
  void ereshape (int w, int h);
  void eidle ();
  void emouse (int btn, int state, int x, int y);
  void emotion (int x, int y);
  void ekeyboard (unsigned char key, int x, int y); 
  static Engine *engine;
private:
  void step ();
  World *wrld;
  SimpleList<Agent> *agents;
  double sens_pos, sens_angle, eyex, eyey, eyez, phi, theta;
  bool run_cont;
  int pointerId, xpos, ypos;
  unsigned long steps;
  GLfloat light_global_ambient[4];
  static GLfloat light_diffuse[4], light_ambient[4], light_specular[4];
  static GLfloat light_attenuation, light_pos[4], light_direction[3];
};

#endif // ENGINE_HXX
    
/// Local Variables:          ***
/// compile-command: "make"   ***
/// End:                      ***
