# config/debug.m4                                       -*- Autoconf -*-
# Apsu autoconf debug option.
#
# This file is part of the apsu project.
# See http://www.langbein.org/software/apsu/.
#
# Copyright (C) 2004 Frank C. Langbein <frank@langbein.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
#
# $Id$

# AC_APSU_OPTION_DEBUG([yes|no])
# ------------------------------ 
# Adds user opption --enable-debug and defines preprocessor symbol
# DEBUG, if debuggin has been enabled. Argument selects the default
# behaviour. If it is not given, the debugging is by default disabled.
AC_DEFUN([AC_APSU_OPTION_DEBUG],[dnl
  AS_VAR_SET(ac_apsu_enable_debug_default, ifelse($1, yes, yes, no))
  AC_ARG_ENABLE([debug], 
	        AC_HELP_STRING([--enable-debug],
                               [enable debugging @<:@default=]AS_VAR_GET(ac_apsu_enable_debug_default)[@:>@]),
                [AS_VAR_SET(ac_apsu_option_debug, "$enableval")],
                [AS_VAR_SET(ac_apsu_option_debug, "no")])
  AC_MSG_CHECKING([for debugging])
  AS_IF([test "$ac_apsu_option_debug" = yes],
        [AC_MSG_RESULT([yes])
         AC_DEFINE(DEBUG, 1, [Define in order to enable debugging])],
        [AC_MSG_RESULT([no])])
])
