// pf/queue.hxx
// PF priority queue.
//
// This file is part of the apsu project.
// See http://www.langbein.org/software/apsu/.
//
// Copyright (C) 2005 Frank C. Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// But WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.

#ifndef PF_QUEUE
#define PF_QUEUE 1

#include <stdlib.h>

namespace PF {


  class Queue {
  public:

    Queue () 
      : head_ (NULL) {
    }

    ~Queue ();

    bool empty () const {
      return head_ == NULL;
    }

    void push (unsigned long x, unsigned long y, double g, double f);
    bool pop (unsigned long &x, unsigned long &y, double &g, double &f);

  private:
    
    class Node {
    public:
      Node (unsigned long x,
	    unsigned long y,
	    double g,
	    double f,
	    Node* n) 
	: x_ (x), y_(y), g_ (g), f_(f), next_ (n) {
      }
      unsigned long x_;
      unsigned long y_;
      double g_;
      double f_;
      Node *next_;
    };

    Node *head_;

  };

}

#endif // PF_QUEUE
