// src/astar.cxx
// PF AStar.
//
// This file is part of the apsu project.
// See http://www.langbein.org/software/apsu/.
//
// Copyright (C) 2005 Frank C. Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// But WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.

#include "config-pf.h"

ID(PF, pf_astar, "$Id: main.c, v1.0 2003/09/01 scmfcl Exp $");

#include <stdio.h>

#include "pf/astar.hxx"
#include "pf/queue.hxx"
#include "pf/map.hxx"

bool PF::AStar::search () {

  queue_ = new PF::Queue ();
  queue_->push (sx_, sy_, 0, heuristic (sx_, sy_));

  while (!queue_->empty ()) {

    unsigned long x, y;
    double g, f;
    queue_->pop (x, y, g, f);

    if (x == ex_ && y == ey_) {
      return true;
    }
    unsigned long nx, ny;
    double c;
    while (map_->expand (x, y, nx, ny, c)) {
      queue_->push (nx, ny, g + c, g + c + heuristic (nx, ny));
    }

  }

  return false;
}
